﻿//v1.2
#include "\x\cba\addons\main\script_macros_common.hpp"
#define COMPONENT Kanavat
#define PREFIX TUN


TUN_SW_Radio = {
    params ["_kanava"];

    //Katsotaan että on radio ja peli päällä.
    if (2 > time) exitWith {};
    if (!(call TFAR_fnc_haveSWRadio)) exitWith {hint "You dont have Short range radio"};

    //Valmiin kanavan tai itse määritetyn taajuuden valinta.
    if (_kanava <= 6) then {
        [(call TFAR_fnc_activeSwRadio), _kanava -1] call TFAR_fnc_setSwChannel;
         hintSilent format ["Vaihdettu kanavalle %1",_kanava];
    } else {
        [(call TFAR_fnc_activeSwRadio), 6] call TFAR_fnc_setSwChannel;
        [(call TFAR_fnc_activeSwRadio), str _kanava] call TFAR_fnc_setSwFrequency;
         hintSilent format ["Vaihdettu taajuudelle %1\nkanavapaikalle 7",_kanava];
    };
};

TUN_SW_Radio_Add = {
    params ["_kanava"];
    private ["_Taajuus"];

    //Katsotaan että on radio ja peli päällä.
    if (2 > time) exitWith {};
    if (!(call TFAR_fnc_haveSWRadio)) exitWith {hint "You dont have Short range radio"};
    if (toLower call TFAR_fnc_activeSwRadio select [0,11] in ["tf_rf7800st","tf_anprc154","tf_pnr1000a"]) exitWith {hintSilent "Radio does not support additional channel"};


    if !(-1 == (call TFAR_fnc_ActiveSwRadio) call TFAR_fnc_getAdditionalSwChannel) then {
        [(call TFAR_fnc_activeSwRadio), 7] call TFAR_fnc_setAdditionalSwChannel;
    };

    _vanhakanava = (call TFAR_fnc_ActiveSwRadio) call TFAR_fnc_getSwChannel;

    if (_kanava >= 7) then {
        _Taajuus = _kanava;
    } else {
        [(call TFAR_fnc_activeSwRadio), _kanava -1] call TFAR_fnc_setSwChannel;
        _Taajuus = (call TFAR_fnc_ActiveSwRadio) call TFAR_fnc_getSwFrequency;
    };

    [(call TFAR_fnc_activeSwRadio), 7] call TFAR_fnc_setSwChannel;
    [(call TFAR_fnc_activeSwRadio), _Taajuus] call TFAR_fnc_setSwFrequency;
    [(call TFAR_fnc_activeSwRadio), 7] call TFAR_fnc_setAdditionalSwChannel;
    [(call TFAR_fnc_activeSwRadio), _vanhakanava] call TFAR_fnc_setSwChannel;
    hintSilent format ["Additionaali asetettu taajuudelle %1\nkanavapaikalle 8",_Taajuus];
};

TUN_LR_Radio = {
    params ["_Taajuus","_kanava"];
    //Katsotaan että on radio ja peli päällä.
    if (2 > time) exitWith {};
    if (!(call TFAR_fnc_haveLRRadio)) exitWith {hint "You dont have Long Range Radio"};

    if (30 <= _Taajuus && 87 >= _Taajuus) then {
        [(call TFAR_fnc_activeLrRadio) select 0, (call TFAR_fnc_activeLrRadio) select 1, _kanava] call TFAR_fnc_setLrChannel;

        if !( str _Taajuus == (call TFAR_fnc_ActiveLrRadio) call TFAR_fnc_getLrFrequency) then {
            [(call TFAR_fnc_activeLrRadio) select 0, (call TFAR_fnc_activeLrRadio) select 1, str _Taajuus] call TFAR_fnc_setLrFrequency;
        };
       hintSilent format ["Vaihdettu taajuudelle %1 ja kanavapaikalle %2",_Taajuus,_kanava+1];
    } else {
        hint "taajuutta ei voi käyttää";
    };

};

TUN_LR_Radio_Add = {
    params ["_kanava"];

    //Katsotaan että on radio ja peli päällä.
    if (2 > time) exitWith {};
    if (!(call TFAR_fnc_haveLRRadio)) exitWith {hint "You dont have Long Range Radio"};

    _vanhakanava = (call TFAR_fnc_ActiveLrRadio) call TFAR_fnc_getLrChannel;
    if (30 <= _kanava && 87 >= _kanava) then {
        if !(-1 == (call TFAR_fnc_ActiveLrRadio) call TFAR_fnc_getAdditionalLrChannel) then {
            [(call TFAR_fnc_activeLrRadio) select 0, (call TFAR_fnc_activeLrRadio) select 1, 8] call TFAR_fnc_setAdditionalLrChannel;
        };

        [(call TFAR_fnc_activeLrRadio) select 0, (call TFAR_fnc_activeLrRadio) select 1, 8] call TFAR_fnc_setAdditionalLrChannel;
        [(call TFAR_fnc_activeLrRadio) select 0, (call TFAR_fnc_activeLrRadio) select 1, 8] call TFAR_fnc_setLrChannel;

        if !( str _kanava == (call TFAR_fnc_ActiveLrRadio) call TFAR_fnc_getLrFrequency) then {
            [(call TFAR_fnc_activeLrRadio) select 0, (call TFAR_fnc_activeLrRadio) select 1, str _kanava] call TFAR_fnc_setLrFrequency;
        };

        [(call TFAR_fnc_activeLrRadio) select 0, (call TFAR_fnc_activeLrRadio) select 1, _vanhakanava] call TFAR_fnc_setLrChannel;
        hintSilent format ["Additionaali asetettu taajuudelle %1",_kanava];

    } else {
        hint "taajuutta ei voi käyttää";
    };
};


TUN_FNC_Radio_Lisakanavat =
{
    params ["_ok","_vanha","_Kanava_LR"];
    private ["_Radiotaajuus"];
        if (_ok == "ei_ylimaaraista") exitWith {};

        while {true} do {
            _Radiotaajuus = round(random [30, 50, 87]);
            if !(_Radiotaajuus in GVAR(Kaitetyt_Numerot)) exitWith {};
        };

        GVAR(Kaitetyt_Numerot) pushBack _Radiotaajuus;
        UNIQUE(GVAR(Kaitetyt_Numerot));

        if !(_Kanava_LR >= 6) then {
            INC(_Kanava_LR);
        } else {
            _Kanava_LR = 7;
        };

         _vanha = format ["%1-%2,   Taajuus %3 (%5)  <execute expression='[%3,%4] call TUN_LR_Radio;'>Vaihda</execute> - <execute expression='[%3] call TUN_LR_Radio_Add;'>Additional</execute> - <execute expression='[%3] call TUN_SW_Radio_Add;'>Lyhyen Additional</execute><br/>",
                //muuttujat
                _vanha,
                _ok splitString "1,2,3,4,5,6,7,8,9,0" select 0,
                _Radiotaajuus,
                _Kanava_LR,
                _Kanava_LR + 1
        ];
    [_vanha,_Kanava_LR]
};




GVAR(Kanava_SW_Civilian) = 0;
GVAR(Kanava_SW_Independent) = 0;
GVAR(Kanava_SW_East) = 0;
GVAR(Kanava_SW_West) = 0;

GVAR(Kanava_LR_Civilian) = -1;
GVAR(Kanava_LR_Independent) = -1;
GVAR(Kanava_LR_East) = -1;
GVAR(Kanava_LR_West) = -1;

GVAR(JobsDone) = false;
GVAR(Kaitetyt_Numerot) = [];


GVAR(SW_Kokonaisuus_West) = "";
GVAR(LR_Kokonaisuus_West) = "";
GVAR(SW_Kokonaisuus_East) = "";
GVAR(LR_Kokonaisuus_East) = "";
GVAR(SW_Kokonaisuus_Independent) = "";
GVAR(LR_Kokonaisuus_Independent) = "";
GVAR(SW_Kokonaisuus_Civilian) = "";
GVAR(LR_Kokonaisuus_Civilian) = "";
